--################################################################
-- written by CrisOHara
-- Version 2
-- 21 January 2023
-- This software is free
--
-- The script is developed for x9lite-S openTx 2.3.15 (but likely to run on some other radio)
-- Cause some of the used values depend on "magic" numbers it may be nessesary to adapt for other radios
-- The hardware dependency is base on the fact that different type of radios do have a different amount of switches.
-- Also different software version may have an effect.
-- So please check on companion first (or at least use a copy of an existing model)
--
-- Script can be used as telemetry script in a telemetry view (but has to run only once so it should be removed after first run)
--   or with execute when selected from the file menu direct from sdcard (that's what I prefer)
-- Be aware that you have to select to model as active model first.
--
--
--
-- this example script creates:
--    does not make any changes to your model
--    it only checks whether the Trim definition in the input lines are correct (neccessary  after running InpBud.lua due to an error in OTX-LUA)
--
-- no warranty: script is to be used on your own risk
--
--######################################################################


--#####  check inputs (trims) for Trainer ########################

--########### init function ############################################
-- global variables
local errorOnIndex = 0;
local  indexSwitchLS01, indexSourceTR01, indexSourceMAX, indexSourceCH01, indexSwitchTele, indexSourceRud, lineSizeMID, lineSizeSML
-- function
local function InpChc_init()
       --##### defining of Indes for LS01, TR1, CH01, Max ### depends on radio Type ### x9Lite = 36
	chunk, err = loadScript("/SCRIPTS/FUNCTIONS/trainer/indLib.lua");
	if err then
	   errorOnIndex = 1;
	   return;
	   end;
        local script=chunk();
        indexSwitchLS01, indexSourceTR01, indexSourceMAX, indexSourceCH01, indexSwitchTele, indexSourceRud, lineSizeMID, lineSizeSML = script.init();
end



-- ############################### run function #####################
local function InpChc_run(event)

local inputData = { name, inputName, source, weight, offset, switch, curveType, curveValue, carryTrim, flightModes};
local inputNumber;
local lineAmount;
local lineNr;
local ii;

	lcd.clear();
	if lineSizeMID == nil then lineSizeMID = 17; lineSizeSML = 9; end

        ii=0;
	for inputNumber = 0 , 31 do
	
	   lineAmount = model.getInputsCount(inputNumber);
	   if (lineAmount > 0) then
              for lineNr = 0, lineAmount-1 do
		inputData = model.getInput(inputNumber, lineNr);

		  if (inputData.source == indexSourceCH01 + 28)  and (inputData.carryTrim ~= -4) then  --###### Aileron Buddy
                     lcd.drawText (0,ii,"Trim I01 wrong", MIDSIZE);
		     ii=ii+lineSizeMID;
		     end;

		  if (inputData.source == indexSourceCH01 + 29)  and (inputData.carryTrim ~= -2) then  --###### Elevator Buddy
                     lcd.drawText (0,ii,"Trim I02 wrong", MIDSIZE);
		     ii=ii+lineSizeMID;
		     end;

		  if (inputData.source == indexSourceCH01 + 30)  and (inputData.carryTrim ~= -3) then  --###### Trottle Buddy
                     lcd.drawText (0,ii,"Trim I03 wrong", MIDSIZE);
		     ii=ii+lineSizeMID;
		     end;

		  if (inputData.source == indexSourceCH01 + 31)  and (inputData.carryTrim ~= -1) then  --###### Ruder Buddy
                     lcd.drawText (0,ii,"Trim I04 wrong", MIDSIZE);
		     ii=ii+lineSizeMID;
		     end;
              end
	    end
	end
                if (ii == 0) then lcd.drawText (0,lineSizeMID,"all Trims ok", MIDSIZE) end;

	return 0;
end

return { init=InpChc_init, run=InpChc_run };