--####################################################################################
-- written by ChrisOHara 25.01.2023
--
-- this software is freen, no garantee so it's uasage is on your own risc
--
-- this script is not designed to run on it's own.
-- it is a kind of library function so it can be loaded by other scripts.
--
-- the function reurns "magic" numbers for specific radios
--
-- return values are:
--
--   index number of first logical switch "ls01"
--   index number of first Switch "telemetry"
--   index of source "MAX"
--   index of source "trn01"
--   index of source "ch01"
--   index of source "rud"
--
-- to be used for functions like model.setMixer()
--
--###########################################################

-- local for all functions in script
local indexSwitchLS01;	  -- Switch ID for LS01
local indexSourceTR01;    -- Source ID for TR01
local indexSourceMAX;	  -- Source ID of MAX Value for CustomFunction
local indexSourceRud;	  -- Switch ID for LS01
local indexSourceCH01;    -- Switch ID for ch01
local indexSwitchTele;    -- Switch ID for Telemetry
local lineSizeMID;        -- for size of line using lcdDrawText
local lineSizeSML;        -- for size of line using lcdDrawText

local radioType;
local ver, radio, maj, minor, rev, osName = getVersion();
	_, _, radioType = string.find(radio, "(%w+)-")
	if radioType == nil then radioType = radio; end;
local   osVersion =maj*10000 + minor*100 + rev ;



--##### function for defining of Indes for LS01, TR1, CH01, Max ### depends on radio Type ### x9Lite = 36

local function findingIndexes()

--  looking for switches - OpenTx and EdgeTx including version up to 2.5
if (osName == "OpenTX")   or   ((osName == "EdgeTX")  and  (osVersion < 20600)) then
	if        radioType == "x9e"     then
			indexSwitchLS01 = 87;
	   elseif radioType == "x9lites" then
			indexSwitchLS01 = 36;
	   elseif radioType == "x9lite" then
			indexSwitchLS01 = 30;
	   elseif radioType == "xlite" then
			indexSwitchLS01 = 39;
	   elseif radioType == "xlites" then
			indexSwitchLS01 = 39;
	   elseif radioType == "x9d+2019" then
			indexSwitchLS01 = 54 ;
	   elseif radioType == "x9d+" then
			indexSwitchLS01 = 54 ;
	   elseif radioType == "x9d" then
			indexSwitchLS01 = 54 ;
	   elseif radioType == "x7access" then
			indexSwitchLS01 = 45 ;
	   elseif radioType == "x7" then
			indexSwitchLS01 = 45 ;
	   elseif radioType == "x10" then
			indexSwitchLS01 = 73 ;
 	   elseif radioType == "x10express" then
			indexSwitchLS01 = 73 ;
	   elseif radioType == "x12s" then
			indexSwitchLS01 = 61 ;
	   elseif radioType == "t12" then             -- Jumper
			indexSwitchLS01 = 45 ;
	   elseif radioType == "tpro" then
			indexSwitchLS01 = 51 ;
	   elseif radioType == "t16" then
			indexSwitchLS01 = 73 ;
	   elseif radioType == "t18" then
			indexSwitchLS01 = 73 ;
	   elseif radioType == "tx12" then             -- Radiomaster
			indexSwitchLS01 = 45 ;
	   elseif radioType == "zorro" then
			indexSwitchLS01 = 45 ;
	   elseif radioType == "t8" then
			indexSwitchLS01 = 45 ;
	   elseif radioType == "tx16s" then
			indexSwitchLS01 = 73 ;
 	   else                               
			indexSwitchLS01 = 54;   -- catchall, if radio is not found (is x9d)
	  end

        indexSwitchTele = indexSwitchLS01 + 75;    -- index für Telemetry on

    end

--  looking for switches - EdgeTx version 2.6 and higher
if  ((osName == "EdgeTX")  and  (osVersion >= 20600)) then

        indexSwitchTele = getSwitchIndex("Tele");
	indexSwitchLS01 = getSwitchIndex("L01");
        if (indexSwitchLS01 == nil) then 
             model.setLogicalSwitch(0,{func = LS_FUNC_AND, v1 = 1, v2 = 1});
             indexSwitchLS01 = getSwitchIndex("L01");
             model.setLogicalSwitch(0,{func = 0, v1 = 0, v2 = 0});
           end
      end

-- looking for sources  (OpenTX and EdgeTX in common)

          indexSourceTR01 = getFieldInfo("trn1") and getFieldInfo("trn1").id or nil;
          indexSourceCH01 = getFieldInfo("ch1") and getFieldInfo("ch1").id or nil;
          indexSourceMAX  = getFieldInfo("max") and getFieldInfo("max").id or nil;
          indexSourceRud  = getFieldInfo("rud") and getFieldInfo("rud").id or nil;
          if  LCD_H < 100  then 
               lineSizeMID = 17;   -- for Taranis and other small Displays
               lineSizeSML = 9;
             else
               lineSizeMID = 34;   -- for Horus and other large Displays
               lineSizeSML = 18; 
             end

-- return the values

    return indexSwitchLS01, indexSourceTR01, indexSourceMAX, indexSourceCH01, indexSwitchTele, indexSourceRud, lineSizeMID, lineSizeSML;
 

end


local function run()
	lcd.clear()
	lcd.drawText (0,  0,radioType.."  >"..osName.."<  "..osVersion,SMLSIZE);
	lcd.drawText (0, 11,"L01 = "..indexSwitchLS01, SMLSIZE);
	lcd.drawText (0, 20,"TR1 = "..indexSourceTR01, SMLSIZE);
	lcd.drawText (0, 29,"MAX = "..indexSourceMAX, SMLSIZE);
	lcd.drawText (0, 38,"CH1 = "..indexSourceCH01, SMLSIZE);
	lcd.drawText (0, 47,"Tele= "..indexSwitchTele, SMLSIZE);
	lcd.drawText (0, 56,"Rud = "..indexSourceRud, SMLSIZE);
return 0
end

return {init=findingIndexes, run=run}